#include <vector>
#include <iostream>

struct reporter {
	int id;

	reporter(int id) : id(id) {
		std::cout << id << " created\n";
	}
	reporter(const reporter& other) : id(other.id) {
		std::cout << id << " copied\n";
	}
	~reporter() {
		std::cout << id << " destroyed\n";
	}
	/*
	reporter(reporter&& other) noexcept : id(other.id) {
		other.id *= -1;
		std::cout << id << " moved\n";
	}
	*/
};

int main() {
	std::vector<reporter> vr;

	for (int i = 0; i < 10; ++i) {
		std::cout << "--- " << i << " ---\n";
		vr.emplace_back(i);
	}

	std::cout << "--- end of main ---\n";
}
