#include <iostream>

struct reporter {
	int id;
	reporter(int id) : id{ id } {
		std::cout << id << " created\n";
	}

	reporter(const reporter& other) : id{ other.id + 100 } {
		std::cout << id << " copied from " << other.id << '\n';
	}
};

struct bundle {
	reporter a, b;
};

int main() {
	reporter r1 = { 1 };
	reporter r2 = { 2 };
	std::cout << "---\n";

	reporter r3 = r1;
	reporter r4 = r2;
	std::cout << "---\n";

	bundle b = { r3, r4 };
	std::cout << "---\n";
	bundle c = b;
	std::cout << "---\n";
}
