#include <iostream>

struct rectangle {
	int width, height;
	rectangle(int w, int h)
	  : width{ w }, height{ h } {}
	rectangle(int x) : rectangle{ x, x } {}

	void show() const {
		std::cout << width << " × " << height << '\n';
	}
};

int main() {
	rectangle r1 = { 2, 3 };
	rectangle r2 = { 7 };

	r1.show();
	r2.show();
}
