#include <array>
#include <iostream>

struct reporter {
	int id;
	reporter(int id) : id{ id } {
		std::cout << id << " created\n";
	}

	~reporter() {
		std::cout << id << " destroyed\n";
	}

};

struct bundle {
	reporter a, b;
	~bundle() {
		std::cout << "bundle destroyed\n";
	}
};

reporter gr = { -1 };

int main() {
	reporter r0 = { 0 };

	{
		reporter r1 = { 1 };
		reporter r2 = { 2 };
	}

	reporter r3 = { 3 };

	{
		bundle b = { { 4 }, { 5 } };
	}

	std::array arr = {
		reporter{ 6 },
		reporter{ 7 },
		reporter{ 8 },
		reporter{ 9 },
	};
	std::cout << "--- end of main ---\n";
}
